
import { Service, ServiceBroker, Context } from 'moleculer';
import { Container } from 'inversify';
import { KubectlApi } from '../services';
import { IExposePortRequest } from '../interfaces';
import { IMoleculerServiceName, IKubectlServiceAction } from '@container-stack/core';



export class KubectlMoleculerService extends Service {

    private kubectl: KubectlApi;
    constructor(broker: ServiceBroker, { container, ...settings }: { container: Container }) {
        super(broker);
        const topic = IMoleculerServiceName.KubectlService;
        this.kubectl = new KubectlApi();


        this.parseServiceSchema({
            name: topic,
            actions: {
                [IKubectlServiceAction.exposePort]: {
                    handler: async (ctx: Context<{ exposePortRequest: IExposePortRequest }>) => {
                        return await this.kubectl.exposePort(ctx.params.exposePortRequest);
                    },
                },
            },
        });
    }
}
