import * as k8s from '@kubernetes/client-node';
import { IExposePortRequest } from '../interfaces/index';

const kube = k8s.Config.defaultClient();

export class KubectlApi {

    public async exposePort(exposePortRequest: IExposePortRequest) {

        let pod: k8s.V1Pod;
        let service = new k8s.V1Service();
        let port = new k8s.V1ServicePort();
        let exposed: string;

        kube.readNamespacedPod(exposePortRequest.podName, exposePortRequest.nameSpace).then(result => {
            pod = result.body;
            port.port = exposePortRequest.port;
            port.targetPort = exposePortRequest.targetPort as any;
            port.protocol = exposePortRequest.protocol;

            service.metadata = new k8s.V1ObjectMeta();
            service.metadata.name = exposePortRequest.name;
            service.metadata.namespace = exposePortRequest.nameSpace;
            service.spec = new k8s.V1ServiceSpec();
            service.spec.type = 'LoadBalancer';
            service.spec.ports = [port];
            service.spec.selector = pod.metadata.labels;
        kube.createNamespacedService(exposePortRequest.nameSpace, service).catch(err => {console.error(err); });
        });
    }
}
